using System;
using System.Runtime.InteropServices; // For the DllImport of DPS Driver API

namespace DPSNet
{
	public class DPS
	{
		[UnmanagedFunctionPointer(CallingConvention.StdCall)]
		public delegate void TScanVCallback(IntPtr pData, UInt32 DataCount);



		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_Open")]
		public static extern UInt32 Open();

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_Close")]
		public static extern UInt32 Close(UInt32 hSession);



		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_SetRange")]
		public static extern UInt32 SetRange(UInt32 hSession, byte Range);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_SetRanges")]
		public static extern UInt32 SetRanges(UInt32 hSession, [In] byte pRanges, UInt32 RangeBytes);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_GetRanges")]
		public static extern UInt32 GetRanges(UInt32 hSession, [In] byte pRanges, UInt32 RangeBytes);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_SetRate")]
		public static extern UInt32 SetRate(UInt32 hSession, double CallbackHz);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_GetRate")]
		public static extern UInt32 GetRate(UInt32 hSession, [Out] double CallbackHz);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_SetCallback")]
		public static extern UInt32 SetCallback(UInt32 hSession, TScanVCallback pCallback);



		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_SelectDevice")]
		public static extern UInt32 SelectDevice(UInt32 hSession, UInt32 DeviceIndex);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_GetDeviceSelection")]
		public static extern UInt32 GetDeviceSelection(UInt32 hSession, [Out] UInt32 pDeviceIndexMethod, [Out] UInt32 pEffectiveDeviceIndex);



		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_StartAcquisition")]
		public static extern UInt32 StartAcquisition(UInt32 hSession);

		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_StopAcquisition")]
		public static extern UInt32 StopAcquisition(UInt32 hSession);



		[DllImport("DAQPACKSTREAM.DLL", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall, EntryPoint="DPS_RangesRateCallbackStart")]
		public static extern UInt32 RangesRateCallbackStart(UInt32 hSession, [In] byte pRanges, UInt32 RangeBytes, double CallbackHz, TScanVCallback pCallback);
	}

}

