unit DaqPackStream;

interface

uses
  Windows, SysUtils;

const
  DPSDLL = 'DaqPackStream.dll';

type
  TSessionHandle = LongWord;
  TPScanVCallback = procedure (pData: PDouble; DataCount: LongWord); stdcall;

function DPS_Open: TSessionHandle; stdcall; external DPSDLL;
function DPS_Close(SH: TSessionHandle): LongWord; stdcall; external DPSDLL;

function DPS_SelectDevice(SH: TSessionHandle; DeviceIndex: LongWord): LongWord; stdcall; external DPSDLL;
function DPS_GetDeviceSelection(SH: TSessionHandle; pDeviceIndexMethod, pEffectiveDeviceIndex: PLongWord): LongWord; stdcall; external DPSDLL;

function DPS_SetRange(SH: TSessionHandle; Range: Byte): LongWord; stdcall; external DPSDLL;
function DPS_SetRanges(SH: TSessionHandle; pRanges: PByte; RangeBytes: LongWord): LongWord; stdcall; external DPSDLL;
function DPS_GetRanges(SH: TSessionHandle; pRanges: PByte; RangeBytes: LongWord): LongWord; stdcall; external DPSDLL;
function DPS_SetRate(SH: TSessionHandle; CallbackHz: Double): LongWord; stdcall; external DPSDLL;
function DPS_GetRate(SH: TSessionHandle; var CallbackHz: Double): LongWord; stdcall; external DPSDLL;
function DPS_SetCallback(SH: TSessionHandle; pCallback: TPScanVCallback): LongWord; stdcall; external DPSDLL;

function DPS_StartAcquisition(SH: TSessionHandle): LongWord; stdcall; external DPSDLL;
function DPS_StopAcquisition(SH: TSessionHandle): LongWord; stdcall; external DPSDLL;

function DPS_RangesRateCallbackStart(SH: TSessionHandle; pRanges: PByte; RangeBytes: LongWord; CallbackHz: Double; pCallback: TPScanVCallback): LongWord; stdcall; external DPSDLL;

implementation

end.
